/*
 * Copyright (C) Sapphirecode - All Rights Reserved
 * This file is part of Requestor which is released under BSD-3-Clause.
 * See file 'LICENSE' for full license details.
 * Created by Timo Hocker <timo@scode.ovh>, March 2020
 */

/* eslint-disable no-process-exit */
/* eslint-disable no-console */
/* eslint-disable no-sync */
'use strict';

const fs = require ('fs');
const child_process = require ('child_process');

const pkg = JSON.parse (fs.readFileSync ('package.json', 'utf-8'));
[
  ,, pkg.version
] = process.argv;
fs.writeFileSync ('package.json', JSON.stringify (pkg, null, 2));

child_process.execSync ('yarn lint', { stdio: 'inherit' });
if (typeof pkg.scripts !== 'undefined' && typeof pkg.scripts.test === 'string')
  child_process.execSync ('yarn test', { stdio: 'inherit' });

child_process.exec ('git log -1 | grep \'\\[no publish\\]\'')
  .addListener ('exit', (code) => {
    if (code === 0) {
      console.log ('build not marked for deployment');
      process.exit (1);
    }
    else { child_process.execSync ('yarn publish'); }
  });
